//+------------------------------------------------------------------+
//|                                      !Trade4me_interface.mq4.mq4 |
//|                                                     SAS NEUTRINO |
//|                                                 http://Trade4.me |
//+------------------------------------------------------------------+
#property copyright "SAS NEUTRINO"
#property link      "https://Trade4.me"
#property version   "1.00"
#property strict

#include "..\Include\!Trade4me_functions.mqh"

extern string iusername = "testusername"; // Your trade4me username
extern string ipassword = "testpassword"; // Your trade4me password
extern double balance   = 1000;       //Simulated Balance
extern double payout    = 80;         //Simulated Payout Percentage

double binary[][6]; //openTime, openPrice, expirySec, direction, amount, output;
int orders=0;
int nbwin=0, nbloss=0, nbeven=0;
double winratio=0;
double price=0;

int file_handle;
int drawIndex=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
  //if(TimeCurrent()>0) {
      ObjectsDeleteAll(0);
      ArrayInitialize(binary,0.0);
      ArrayFree(binary);
      orders=0;
      nbwin=0; nbloss=0; nbeven=0;
      winratio=0;
      price=0;
      drawIndex=0;
      
      ChartSetInteger(0,CHART_MODE,CHART_CANDLES);
      ChartSetInteger(0,CHART_FOREGROUND,false);
      ChartSetInteger(0,CHART_SHIFT,true);
      ChartSetInteger(0,CHART_AUTOSCROLL,true);
      ChartSetInteger(0,CHART_SCALE,3);
      ChartSetInteger(0,CHART_SCALEFIX,false);
      ChartSetInteger(0,CHART_SCALEFIX_11,false);
      ChartSetInteger(0,CHART_SCALE_PT_PER_BAR,false);
      ChartSetInteger(0,CHART_SHOW_OHLC,false);
      ChartSetInteger(0,CHART_SHOW_BID_LINE,true);
      ChartSetInteger(0,CHART_SHOW_ASK_LINE,false);
      ChartSetInteger(0,CHART_SHOW_LAST_LINE,false);
      ChartSetInteger(0,CHART_SHOW_PERIOD_SEP,false);
      ChartSetInteger(0,CHART_SHOW_GRID,false);
      ChartSetInteger(0,CHART_SHOW_VOLUMES,false);
      ChartSetInteger(0,CHART_SHOW_OBJECT_DESCR,false);
      ChartSetInteger(0,CHART_COLOR_BACKGROUND,C'255,255,255');
      ChartSetInteger(0,CHART_COLOR_FOREGROUND,DarkGray);
      ChartSetInteger(0,CHART_COLOR_GRID,DarkGray);
      ChartSetInteger(0,CHART_COLOR_VOLUME,DarkGray);
      ChartSetInteger(0,CHART_COLOR_CHART_UP,C'0,174,232');
      ChartSetInteger(0,CHART_COLOR_CHART_DOWN,C'173,173,173');
      ChartSetInteger(0,CHART_COLOR_CHART_LINE,Gray);
      ChartSetInteger(0,CHART_COLOR_CANDLE_BULL,C'0,174,232');
      ChartSetInteger(0,CHART_COLOR_CANDLE_BEAR,C'173,173,173');
      ChartSetInteger(0,CHART_COLOR_BID,DarkGray);
      ChartSetInteger(0,CHART_COLOR_ASK,DarkGray);
      ChartSetInteger(0,CHART_COLOR_LAST,DarkGray);
      ChartSetInteger(0,CHART_COLOR_STOP_LEVEL,DarkGray);
      ChartSetInteger(0,CHART_SHOW_TRADE_LEVELS,false);
      ChartSetInteger(0,CHART_DRAG_TRADE_LEVELS,false);
      ChartSetInteger(0,CHART_SHOW_DATE_SCALE,true);
      ChartSetInteger(0,CHART_SHOW_PRICE_SCALE,true);
      ChartSetInteger(0,CHART_SHOW_ONE_CLICK,false);
      
      long result=-1;
      ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0,result);
      ChartSetDouble(0,CHART_SHIFT_SIZE,300.0*100.0/(result*1.0)+1.0);
      
      if(TerminalInfoInteger(TERMINAL_DLLS_ALLOWED)==false){
             ObjectCreate(0,"Trade4me-DLL",OBJ_LABEL,0,0,0);
         ObjectSetInteger(0,"Trade4me-DLL",OBJPROP_ZORDER,10);
         ObjectSetInteger(0,"Trade4me-DLL",OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
          ObjectSetString(0,"Trade4me-DLL",OBJPROP_TEXT,"Please allow DLL import in Tools/Options/Expert Advisors.");
         ObjectSetInteger(0,"Trade4me-DLL",OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(0,"Trade4me-DLL",OBJPROP_FONTSIZE,20);
         ObjectSetInteger(0,"Trade4me-DLL",OBJPROP_XDISTANCE,100);
         ObjectSetInteger(0,"Trade4me-DLL",OBJPROP_YDISTANCE,100);
         ObjectSetInteger(0,"Trade4me-DLL",OBJPROP_COLOR,C'237,58,95');
      }
     
          ObjectCreate(0,"Trade4me--bg",OBJ_RECTANGLE_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--bg",OBJPROP_ZORDER,3);
      ObjectSetInteger(0,"Trade4me--bg",OBJPROP_XDISTANCE,300);
      ObjectSetInteger(0,"Trade4me--bg",OBJPROP_YDISTANCE,0);
      ObjectSetInteger(0,"Trade4me--bg",OBJPROP_XSIZE,300);
      ObjectSetInteger(0,"Trade4me--bg",OBJPROP_YSIZE,1300);
      ObjectSetInteger(0,"Trade4me--bg",OBJPROP_BGCOLOR,C'248,248,248');
      ObjectSetInteger(0,"Trade4me--bg",OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
      ObjectSetInteger(0,"Trade4me--bg",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--bg",OBJPROP_COLOR,Orange);
      ObjectSetInteger(0,"Trade4me--bg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,"Trade4me--bg",OBJPROP_WIDTH,0);
      
          ObjectCreate(0,"Trade4me--title-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--title-label",OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"Trade4me--title-label",OBJPROP_YDISTANCE,20);
      ObjectSetInteger(0,"Trade4me--title-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
       ObjectSetString(0,"Trade4me--title-label",OBJPROP_TEXT,"TRADE4.ME");
       ObjectSetString(0,"Trade4me--title-label",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"Trade4me--title-label",OBJPROP_FONTSIZE,20);
       ObjectSetDouble(0,"Trade4me--title-label",OBJPROP_ANGLE,0.0);
      ObjectSetInteger(0,"Trade4me--title-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
      ObjectSetInteger(0,"Trade4me--title-label",OBJPROP_COLOR,C'173,173,173');
      ObjectSetInteger(0,"Trade4me--title-label",OBJPROP_BACK,false);
      ObjectSetInteger(0,"Trade4me--title-label",OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,"Trade4me--title-label",OBJPROP_SELECTED,false);
      ObjectSetInteger(0,"Trade4me--title-label",OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,"Trade4me--title-label",OBJPROP_ZORDER,100);
      
          ObjectCreate(0,"Trade4me--expiry-bg",OBJ_RECTANGLE_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--expiry-bg",OBJPROP_ZORDER,4);
      ObjectSetInteger(0,"Trade4me--expiry-bg",OBJPROP_XDISTANCE,300);
      ObjectSetInteger(0,"Trade4me--expiry-bg",OBJPROP_YDISTANCE,40);
      ObjectSetInteger(0,"Trade4me--expiry-bg",OBJPROP_XSIZE,300);
      ObjectSetInteger(0,"Trade4me--expiry-bg",OBJPROP_YSIZE,40);
      ObjectSetInteger(0,"Trade4me--expiry-bg",OBJPROP_BGCOLOR,C'243,243,243');
      ObjectSetInteger(0,"Trade4me--expiry-bg",OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
      ObjectSetInteger(0,"Trade4me--expiry-bg",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--expiry-bg",OBJPROP_COLOR,Orange);
      ObjectSetInteger(0,"Trade4me--expiry-bg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,"Trade4me--expiry-bg",OBJPROP_WIDTH,0);
      
          ObjectCreate(0,"Trade4me--exp-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--exp-label",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--exp-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--exp-label",OBJPROP_TEXT,"Expiry :");
      ObjectSetInteger(0,"Trade4me--exp-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--exp-label",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--exp-label",OBJPROP_XDISTANCE,250);
      ObjectSetInteger(0,"Trade4me--exp-label",OBJPROP_YDISTANCE,59);
      ObjectSetInteger(0,"Trade4me--exp-label",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"Trade4me--exp-label",OBJPROP_FONT,"Arial");
       
          ObjectCreate(0,"Trade4me--exp-min",OBJ_EDIT,0,0,0);
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--exp-min",OBJPROP_TEXT,"1");
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_COLOR,Gray);
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_XDISTANCE,221);
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_YDISTANCE,50);
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_XSIZE,40);
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_YSIZE,20);
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_BGCOLOR,White);
       ObjectSetString(0,"Trade4me--exp-min",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_BORDER_COLOR,Gray);
      ObjectSetInteger(0,"Trade4me--exp-min",OBJPROP_ALIGN,ALIGN_CENTER);
      
          ObjectCreate(0,"Trade4me--exp-label-min",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--exp-label-min",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--exp-label-min",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--exp-label-min",OBJPROP_TEXT,"minutes");
      ObjectSetInteger(0,"Trade4me--exp-label-min",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--exp-label-min",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--exp-label-min",OBJPROP_XDISTANCE,151);
      ObjectSetInteger(0,"Trade4me--exp-label-min",OBJPROP_YDISTANCE,59);
      ObjectSetInteger(0,"Trade4me--exp-label-min",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"Trade4me--exp-label-min",OBJPROP_FONT,"Arial");
      
          ObjectCreate(0,"Trade4me--exp-sec",OBJ_EDIT,0,0,0);
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--exp-sec",OBJPROP_TEXT,"0");
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_COLOR,Gray);
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_XDISTANCE,123);
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_YDISTANCE,50);
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_XSIZE,40);
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_YSIZE,20);
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_BGCOLOR,White);
       ObjectSetString(0,"Trade4me--exp-sec",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_BORDER_COLOR,Gray);
      ObjectSetInteger(0,"Trade4me--exp-sec",OBJPROP_ALIGN,ALIGN_CENTER);
      
          ObjectCreate(0,"Trade4me--exp-label-sec",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--exp-label-sec",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--exp-label-sec",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--exp-label-sec",OBJPROP_TEXT,"seconds");
      ObjectSetInteger(0,"Trade4me--exp-label-sec",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--exp-label-sec",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--exp-label-sec",OBJPROP_XDISTANCE,53);
      ObjectSetInteger(0,"Trade4me--exp-label-sec",OBJPROP_YDISTANCE,59);
      ObjectSetInteger(0,"Trade4me--exp-label-sec",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"Trade4me--exp-label-sec",OBJPROP_FONT,"Arial");
       
          ObjectCreate(0,"Trade4me--price-bg",OBJ_RECTANGLE_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_ZORDER,4);
      ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_XDISTANCE,280);
      ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_YDISTANCE,90);
      ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_XSIZE,260);
      ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_YSIZE,20);
      ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_BGCOLOR,C'243,243,243');
      ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
      ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_WIDTH,0);
      
          ObjectCreate(0,"Trade4me--price-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--price-label",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--price-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--price-label",OBJPROP_TEXT,"0.00000");
      ObjectSetInteger(0,"Trade4me--price-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--price-label",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--price-label",OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"Trade4me--price-label",OBJPROP_YDISTANCE,100);
      ObjectSetInteger(0,"Trade4me--price-label",OBJPROP_COLOR,White);
       ObjectSetString(0,"Trade4me--price-label",OBJPROP_FONT,"Arial");
      
          ObjectCreate(0,"Trade4me--amount-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--amount-label",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--amount-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--amount-label",OBJPROP_TEXT,"Invest:");
      ObjectSetInteger(0,"Trade4me--amount-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--amount-label",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--amount-label",OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"Trade4me--amount-label",OBJPROP_YDISTANCE,130);
      ObjectSetInteger(0,"Trade4me--amount-label",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"Trade4me--amount-label",OBJPROP_FONT,"Arial");
       
          ObjectCreate(0,"Trade4me--amount",OBJ_EDIT,0,0,0);
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--amount",OBJPROP_TEXT,"25");
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_COLOR,Gray);
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_XDISTANCE,185);
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_YDISTANCE,140);
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_XSIZE,70);
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_YSIZE,20);
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_BGCOLOR,White);
       ObjectSetString(0,"Trade4me--amount",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_BORDER_COLOR,Gray);
      ObjectSetInteger(0,"Trade4me--amount",OBJPROP_ALIGN,ALIGN_CENTER);
       
          ObjectCreate(0,"Trade4me--call",OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--call",OBJPROP_TEXT,"UP");
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_XDISTANCE,100);
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_YDISTANCE,90);
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_XSIZE,80);
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_YSIZE,80);
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_BGCOLOR,C'0,174,232');
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_COLOR,White);
       ObjectSetString(0,"Trade4me--call",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_BORDER_COLOR,White);
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_STATE,false);
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,"Trade4me--call",OBJPROP_SELECTED,false);
      
          ObjectCreate(0,"Trade4me--put",OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--put",OBJPROP_TEXT,"DOWN");
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_XDISTANCE,280);
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_YDISTANCE,90);
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_XSIZE,80);
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_YSIZE,80);
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_BGCOLOR,C'173,173,173');
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_COLOR,White);
       ObjectSetString(0,"Trade4me--put",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_BORDER_COLOR,White);
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_STATE,false);
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,"Trade4me--put",OBJPROP_SELECTED,false);
      
          ObjectCreate(0,"Trade4me--balance-bg",OBJ_RECTANGLE_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--balance-bg",OBJPROP_ZORDER,4);
      ObjectSetInteger(0,"Trade4me--balance-bg",OBJPROP_XDISTANCE,300);
      ObjectSetInteger(0,"Trade4me--balance-bg",OBJPROP_YDISTANCE,180);
      ObjectSetInteger(0,"Trade4me--balance-bg",OBJPROP_XSIZE,320);
      ObjectSetInteger(0,"Trade4me--balance-bg",OBJPROP_YSIZE,50);
      ObjectSetInteger(0,"Trade4me--balance-bg",OBJPROP_BGCOLOR,C'243,243,243');
      ObjectSetInteger(0,"Trade4me--balance-bg",OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
      ObjectSetInteger(0,"Trade4me--balance-bg",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--balance-bg",OBJPROP_COLOR,Orange);
      ObjectSetInteger(0,"Trade4me--balance-bg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,"Trade4me--balance-bg",OBJPROP_WIDTH,0);
      
          ObjectCreate(0,"Trade4me--balance-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--balance-label",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--balance-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--balance-label",OBJPROP_TEXT,"Balance : $"+DoubleToString(balance,0));
      ObjectSetInteger(0,"Trade4me--balance-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--balance-label",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--balance-label",OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"Trade4me--balance-label",OBJPROP_YDISTANCE,195);
      ObjectSetInteger(0,"Trade4me--balance-label",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"Trade4me--balance-label",OBJPROP_FONT,"Arial");
       
          ObjectCreate(0,"Trade4me--winloss-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--winloss-label",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--winloss-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--winloss-label",OBJPROP_TEXT,"0 Wins - 0 Losses - 0 Ties - 0.0%");
      ObjectSetInteger(0,"Trade4me--winloss-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--winloss-label",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--winloss-label",OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"Trade4me--winloss-label",OBJPROP_YDISTANCE,215);
      ObjectSetInteger(0,"Trade4me--winloss-label",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"Trade4me--winloss-label",OBJPROP_FONT,"Arial");
   
      string fileName="!MBO_Simulator_Results_"+IntegerToString((int)TimeCurrent())+".csv";
      //if(IsTesting()) fileName="../../MQL4/Files/TESTER"+fileName;
      
      file_handle=FileOpen(fileName,FILE_WRITE|FILE_CSV);
      
      if(file_handle!=INVALID_HANDLE){
         Print("Simulator results in : "+TerminalInfoString(TERMINAL_DATA_PATH)+"\\Files\\"+fileName); 
         FileWrite(file_handle,"Open Time","Open Price","Direction","Expiry","Investment","Close Time","Close Price","Result","Payout","Balance");
      }
      else PrintFormat("Simulator results failed : ERROR N"+IntegerToString(GetLastError()));
      
      EventSetTimer(1);
  //}
   return(INIT_SUCCEEDED);
}

void OnTick()
  {
   //if(TimeCurrent()>0) {
      //double close[1]; CopyClose(NULL,0,0,1,close);
      if(SymbolInfoDouble(_Symbol,SYMBOL_BID)>price) ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_BGCOLOR,C'0,174,232');
      else if(SymbolInfoDouble(_Symbol,SYMBOL_BID)<price) ObjectSetInteger(0,"Trade4me--price-bg",OBJPROP_BGCOLOR,C'173,173,173');
      price=SymbolInfoDouble(_Symbol,SYMBOL_BID);
      ObjectSetString(0,"Trade4me--price-label",OBJPROP_TEXT,DoubleToString(price,5));
      
      updateBinary();
   //}
  }
//+------------------------------------------------------------------+

void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   if(id==CHARTEVENT_OBJECT_CLICK) {
      if(sparam=="Trade4me--put") {
	     double expirySec = StringToDouble(ObjectGetString(0, "Trade4me--exp-min", OBJPROP_TEXT))*60.0+StringToDouble(ObjectGetString(0, "Trade4me--exp-sec", OBJPROP_TEXT));
        double amount    = StringToDouble(ObjectGetString(0, "Trade4me--amount", OBJPROP_TEXT));
        double direction = -1;
        //MqlRates rates[1]; int copied = CopyRates(NULL,0,0,1,rates);
   	  //openBinary(rates[0].time,rates[0].close,expirySec,direction,amount); 
   	  openBinary((double)TimeCurrent(),SymbolInfoDouble(_Symbol,SYMBOL_BID),expirySec,direction,amount);
   	  ObjectSetInteger(0,"Trade4me--put",OBJPROP_SELECTED,false);
   	  ObjectSetInteger(0,"Trade4me--put",OBJPROP_STATE,false);
	   }
	   else if(sparam=="Trade4me--call") {
	     double expirySec = StringToDouble(ObjectGetString(0, "Trade4me--exp-min", OBJPROP_TEXT))*60.0+StringToDouble(ObjectGetString(0, "Trade4me--exp-sec", OBJPROP_TEXT));
        double amount    = StringToDouble(ObjectGetString(0, "Trade4me--amount", OBJPROP_TEXT));
        double direction = 1;
   	  //MqlRates rates[1]; int copied = CopyRates(NULL,0,0,1,rates);
   	  //openBinary(rates[0].time,rates[0].close,expirySec,direction,amount);  
   	  openBinary((double)TimeCurrent(),SymbolInfoDouble(_Symbol,SYMBOL_BID),expirySec,direction,amount);
   	  ObjectSetInteger(0,"Trade4me--call",OBJPROP_SELECTED,false);
   	  ObjectSetInteger(0,"Trade4me--call",OBJPROP_STATE,false);
	   }  
	  ChartRedraw();
   }            
}


int openBinary(double openTime, double openPrice, double expirySec, double direction, double amount){
   
   string response;
   if(direction==1){
       response = trade4me(iusername, ipassword, Symbol(), "UP", DoubleToString(expirySec/60,0), DoubleToString(amount,0));
   }
   else if(direction==-1){
       response = trade4me(iusername, ipassword, Symbol(), "DOWN", DoubleToString(expirySec/60,0), DoubleToString(amount,0));
   }
   Alert(response);
   
   if(StringFind(response,"Successfully")!=-1) {
      orders=orders+1;
      ArrayResize(binary,orders,10000);
      binary[orders-1][0]=(double)TimeCurrent();
      binary[orders-1][1]=SymbolInfoDouble(_Symbol,SYMBOL_BID);
      binary[orders-1][2]=expirySec;
      binary[orders-1][3]=direction;
      binary[orders-1][4]=amount;
      binary[orders-1][5]=0;
         
      if(direction==1){
             ObjectCreate(0,"Trade4me--open-"+IntegerToString(orders),OBJ_ARROW,0,(datetime)openTime,openPrice);
         ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(orders),OBJPROP_ARROWCODE,233); //UP
         ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(orders),OBJPROP_COLOR,C'90,90,90');
         ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(orders),OBJPROP_ZORDER,6);
         ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(orders),OBJPROP_ANCHOR,ANCHOR_TOP);
      }
      else if(direction==-1){
             ObjectCreate(0,"Trade4me--open-"+IntegerToString(orders),OBJ_ARROW,0,(datetime)openTime,openPrice);
         ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(orders),OBJPROP_ARROWCODE,234); //DN
         ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(orders),OBJPROP_COLOR,C'90,90,90');
         ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(orders),OBJPROP_ZORDER,6);
         ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(orders),OBJPROP_ANCHOR,ANCHOR_BOTTOM);
      }
      else Alert("ERROR: direction is invalid.");
      
          ObjectCreate(0,"Trade4me--trend-"+IntegerToString(orders),OBJ_TREND,0,(datetime)openTime,openPrice,(datetime)openTime,openPrice);
      ObjectSetInteger(0,"Trade4me--trend-"+IntegerToString(orders),OBJPROP_COLOR,C'90,90,90');
      ObjectSetInteger(0,"Trade4me--trend-"+IntegerToString(orders),OBJPROP_RAY_LEFT,false);
      ObjectSetInteger(0,"Trade4me--trend-"+IntegerToString(orders),OBJPROP_RAY_RIGHT,false);
      ObjectSetInteger(0,"Trade4me--trend-"+IntegerToString(orders),OBJPROP_STYLE,STYLE_DOT);
      
      int pos=240;
      
          ObjectCreate(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJ_RECTANGLE_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJPROP_ZORDER,4);
      ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJPROP_XDISTANCE,300);
      ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJPROP_YDISTANCE,pos);
      ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJPROP_XSIZE,320);
      ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJPROP_YSIZE,40);
      ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJPROP_BGCOLOR,C'173,173,173');
      ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
      ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJPROP_COLOR,Orange);
      ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(orders),OBJPROP_WIDTH,0);
      
      string directionString="ERROR"; if(direction==1) directionString="UP"; if(direction==-1) directionString="DOWN"; 
          ObjectCreate(0,"Trade4me--option-info-label"+IntegerToString(orders),OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--option-info-label"+IntegerToString(orders),OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--option-info-label"+IntegerToString(orders),OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--option-info-label"+IntegerToString(orders),OBJPROP_TEXT,directionString+" "+Symbol()+" "+TimeToString((datetime)openTime,TIME_SECONDS)+" "+DoubleToString(openPrice,_Digits)+" $"+DoubleToString(amount,0));
      ObjectSetInteger(0,"Trade4me--option-info-label"+IntegerToString(orders),OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--option-info-label"+IntegerToString(orders),OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--option-info-label"+IntegerToString(orders),OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"Trade4me--option-info-label"+IntegerToString(orders),OBJPROP_YDISTANCE,pos+10);
      ObjectSetInteger(0,"Trade4me--option-info-label"+IntegerToString(orders),OBJPROP_COLOR,White);
       ObjectSetString(0,"Trade4me--option-info-label"+IntegerToString(orders),OBJPROP_FONT,"Arial");
       
          ObjectCreate(0,"Trade4me--option-exp-label"+IntegerToString(orders),OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--option-exp-label"+IntegerToString(orders),OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"Trade4me--option-exp-label"+IntegerToString(orders),OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"Trade4me--option-exp-label"+IntegerToString(orders),OBJPROP_TEXT,expirySec<=60?DoubleToString(expirySec,0)+"s":DoubleToString(MathFloor(expirySec/60.0),0)+"m"+DoubleToString(MathMod(expirySec,60),0)+"s");
      ObjectSetInteger(0,"Trade4me--option-exp-label"+IntegerToString(orders),OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--option-exp-label"+IntegerToString(orders),OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"Trade4me--option-exp-label"+IntegerToString(orders),OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"Trade4me--option-exp-label"+IntegerToString(orders),OBJPROP_YDISTANCE,pos+25);
      ObjectSetInteger(0,"Trade4me--option-exp-label"+IntegerToString(orders),OBJPROP_COLOR,White);
       ObjectSetString(0,"Trade4me--option-exp-label"+IntegerToString(orders),OBJPROP_FONT,"Arial");
       
          ObjectCreate(0,"Trade4me--option-exp-bar"+IntegerToString(orders),OBJ_RECTANGLE_LABEL,0,0,0);
      ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(orders),OBJPROP_ZORDER,4);
      ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(orders),OBJPROP_XDISTANCE,300);
      ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(orders),OBJPROP_YDISTANCE,pos+36);
      ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(orders),OBJPROP_XSIZE,320);
      ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(orders),OBJPROP_YSIZE,4);
      ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(orders),OBJPROP_BGCOLOR,C'0,174,232');
      ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(orders),OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
      ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(orders),OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(orders),OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(orders),OBJPROP_WIDTH,0);   
   }
   
   return(true);
}

int updateBinary(){
   for(int i=0; i<ArrayRange(binary,0); i++){
      if(binary[i][5]==0){
         double closePrice = SymbolInfoDouble(_Symbol,SYMBOL_BID);
         if(ObjectFind(0,"Trade4me--trend-"+IntegerToString(i+1))>=0) {
           //double close[1]; CopyClose(NULL,0,0,1,close);
           ObjectSetInteger(0,"Trade4me--trend-"+IntegerToString(i+1),OBJPROP_TIME,1,(int)TimeCurrent());
            ObjectSetDouble(0,"Trade4me--trend-"+IntegerToString(i+1),OBJPROP_PRICE,1,closePrice);
         }
         
         int remainingTime=(int)(binary[i][0]+binary[i][2]-TimeCurrent());
         if(remainingTime<0) remainingTime=0;
         string renTimeString;
         if(remainingTime<=60) renTimeString=DoubleToString(remainingTime,0)+"s";
         else renTimeString=DoubleToString(MathFloor(remainingTime/60.0),0)+"m"+DoubleToString(MathMod(remainingTime,60),0)+"s";
         
          ObjectSetString(0,"Trade4me--option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToString(closePrice,_Digits)+" / "+renTimeString);
         ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(i+1),OBJPROP_XSIZE,(int)(remainingTime*320/binary[i][2]));
         
         if((binary[i][1]<closePrice && binary[i][3]==1) || (binary[i][1]>closePrice && binary[i][3]==-1))
            ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'85,198,136');
         else if((binary[i][1]<closePrice && binary[i][3]==-1) || (binary[i][1]>closePrice && binary[i][3]==1))
            ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'237,58,95');
         else
            ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'173,173,173');
         
         if(TimeCurrent()>=binary[i][0]+binary[i][2]){
            //double close[1]; CopyClose(NULL,0,0,1,close);
            
                ObjectCreate(0,"Trade4me--close-"+IntegerToString(i+1),OBJ_ARROW,0,TimeCurrent(),closePrice);
            ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_ARROWCODE,164);
            ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_COLOR,C'90,90,90');
            ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_ZORDER,7);
            ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_ANCHOR,ANCHOR_CENTER);
            ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_WIDTH,2);
         
            ObjectDelete(0,"Trade4me--option-exp-bar"+IntegerToString(i+1));
            
            if(binary[i][3]==1){ //UP 
               if(binary[i][1]<closePrice){//WIN
                  binary[i][5]=1;
                  ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_ARROWCODE,252);
                  nbwin++;
                  balance=balance+(payout/100)*binary[i][4];
                  ObjectSetString(0,"Trade4me--option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToString(closePrice,_Digits)+" / WON / +$"+DoubleToString((1+payout/100)*binary[i][4],0));
                  ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'85,198,136');
                  ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  ObjectSetInteger(0,"Trade4me--trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  FileWrite(file_handle,TimeToString((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToString(binary[i][1],_Digits),"UP",DoubleToString(binary[i][2],0),DoubleToString(binary[i][4],0),DoubleToString(closePrice,_Digits),TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS),"WIN",DoubleToString((1+payout/100)*binary[i][4],0),DoubleToString(balance,0));
               }
               else if(binary[i][1]>closePrice){//LOSS
                  binary[i][5]=-1;
                  ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_ARROWCODE,251);
                  nbloss++;
                  balance=balance-binary[i][4];
                  ObjectSetString(0,"Trade4me--option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToString(closePrice,_Digits)+" / LOST / -$"+DoubleToString(binary[i][4],0));
                  ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'237,58,95');
                  ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  ObjectSetInteger(0,"Trade4me--trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  FileWrite(file_handle,TimeToString((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToString(binary[i][1],_Digits),"UP",DoubleToString(binary[i][2],0),DoubleToString(binary[i][4],0),DoubleToString(closePrice,_Digits),TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS),"LOSS",DoubleToString(-binary[i][4],0),DoubleToString(balance,0));
               }
               else{//EVEN
                  binary[i][5]=2;
                  nbeven++;
                  //balance=balance+binary[i][4];
                  ObjectSetString(0,"Trade4me--option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToString(closePrice,_Digits)+" / EVEN / $0");
                  ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'173,173,173');
                  ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  ObjectSetInteger(0,"Trade4me--trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  FileWrite(file_handle,TimeToString((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToString(binary[i][1],_Digits),"UP",DoubleToString(binary[i][2],0),DoubleToString(binary[i][4],0),DoubleToString(closePrice,_Digits),TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS),"TIE","0",DoubleToString(balance,0));
               }
            }
            else if(binary[i][3]==-1){ //DN
               if(binary[i][1]>closePrice){//WIN
                  binary[i][5]=1;
                  ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_ARROWCODE,252);
                  nbwin++;
                  balance=balance+(payout/100)*binary[i][4];
                  ObjectSetString(0,"Trade4me--option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToString(closePrice,_Digits)+" / WON / +"+DoubleToString((1+payout/100)*binary[i][4],0));
                  ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'85,198,136');
                  ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  ObjectSetInteger(0,"Trade4me--trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  FileWrite(file_handle,TimeToString((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToString(binary[i][1],_Digits),"DOWN",DoubleToString(binary[i][2],0),DoubleToString(binary[i][4],0),DoubleToString(closePrice,_Digits),TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS),"WIN",DoubleToString((1+payout/100)*binary[i][4],0),DoubleToString(balance,0));
               }
               else if(binary[i][1]<closePrice){//LOSS
                  binary[i][5]=-1;
                  ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_ARROWCODE,251);
                  nbloss++;
                  balance=balance-binary[i][4];
                  ObjectSetString(0,"Trade4me--option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToString(closePrice,_Digits)+" / LOST / -$"+DoubleToString(binary[i][4],0));
                  ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'237,58,95');
                  ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  ObjectSetInteger(0,"Trade4me--trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  FileWrite(file_handle,TimeToString((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToString(binary[i][1],_Digits),"DOWN",DoubleToString(binary[i][2],0),DoubleToString(binary[i][4],0),DoubleToString(closePrice,_Digits),TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS),"LOSS",DoubleToString(-binary[i][4],0),DoubleToString(balance,0));
               }
               else{//EVEN
                  binary[i][5]=2;
                  nbeven++;
                  //balance=balance+binary[i][4];
                  ObjectSetString(0,"Trade4me--option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToString(closePrice,_Digits)+" / EVEN / $0");
                  ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'173,173,173');
                  ObjectSetInteger(0,"Trade4me--open-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  ObjectSetInteger(0,"Trade4me--trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  ObjectSetInteger(0,"Trade4me--close-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  FileWrite(file_handle,TimeToString((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToString(binary[i][1],_Digits),"DOWN",DoubleToString(binary[i][2],0),DoubleToString(binary[i][4],0),DoubleToString(closePrice,_Digits),TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS),"TIE","0",DoubleToString(balance,0));
               }
            }
            else {
               Alert("ERROR: Direction unknown.");
            } 
         }
      }
      else if((binary[i][5]==1 || binary[i][5]==-1 || binary[i][5]==2) && TimeCurrent()>=binary[i][0]+binary[i][2]+300) {
         ObjectDelete(0,"Trade4me--option-info-bg"+IntegerToString(i+1));
         ObjectDelete(0,"Trade4me--option-info-label"+IntegerToString(i+1));
         ObjectDelete(0,"Trade4me--option-exp-label"+IntegerToString(i+1));
         ObjectDelete(0,"Trade4me--option-exp-bar"+IntegerToString(i+1));
      }
   }
   
   organizePositions();
   
   double denom = nbwin+nbloss; if(denom==0.0) denom=1.0;
   winratio=100*nbwin/denom;
   
   ObjectSetString(0,"Trade4me--balance-label",OBJPROP_TEXT,"Balance : $"+DoubleToString(balance,0));
   ObjectSetString(0,"Trade4me--winloss-label",OBJPROP_TEXT,IntegerToString(nbwin)+" Wins - "+IntegerToString(nbloss)+" Losses - "+IntegerToString(nbeven)+" Ties - "+DoubleToString(winratio,1)+"%");
   
   return(true);
}

void organizePositions(){
   int pos=240;
   for(int i=0; i<ArrayRange(binary,0); i++){
      if(ObjectFind(0,"Trade4me--option-info-bg"+IntegerToString(i+1))>=0){
         ObjectSetInteger(0,"Trade4me--option-info-bg"+IntegerToString(i+1),OBJPROP_YDISTANCE,0,pos);
         ObjectSetInteger(0,"Trade4me--option-info-label"+IntegerToString(i+1),OBJPROP_YDISTANCE,0,pos+10);
         ObjectSetInteger(0,"Trade4me--option-exp-label"+IntegerToString(i+1),OBJPROP_YDISTANCE,0,pos+25);
         ObjectSetInteger(0,"Trade4me--option-exp-bar"+IntegerToString(i+1),OBJPROP_YDISTANCE,0,pos+36);
         pos=pos+50;
      }
   }
}

void OnTimer(){
   updateBinary();
}

void OnDeinit(const int reason){
   if(file_handle!=INVALID_HANDLE){
      FileClose(file_handle);
   }
   EventKillTimer();
}
