//+------------------------------------------------------------------+
//|                                          !Trade4me_SELL_Line.mq4 |
//|                                                     SAS NEUTRINO |
//|                                                 http://Trade4.me |
//+------------------------------------------------------------------+

#property copyright "SAS NEUTRINO"
#property link      "https://Trade4.me"
#property indicator_chart_window

#include "..\Include\!Trade4me_functions.mqh"

input double trigger_level = 0;
input string username      = "testusername";
input string password      = "testpassword";
input int    expiry        = 15;
input double investment    = 25;

double trigger;
double prevbid;
string id;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit() 
{  
   trigger = 0; prevbid = SymbolInfoDouble(_Symbol,SYMBOL_BID);
   id = IntegerToString(MathRand());
   if(ObjectFind(0,"trigger_level_dn"+id)>=0){
      if(trigger_level>0) ObjectSetDouble(0,"trigger_level_dn"+id,OBJPROP_PRICE,trigger_level);
      else ObjectSetDouble(0,"trigger_level_dn"+id,OBJPROP_PRICE,SymbolInfoDouble(_Symbol,SYMBOL_BID)+_Point*40);
   }
   else
   {
      if(trigger_level>0){
         ObjectCreate(0,"trigger_level_dn"+id,OBJ_HLINE,0,0,trigger_level);
      }
      else {
         ObjectCreate(0,"trigger_level_dn"+id,OBJ_HLINE,0,0,SymbolInfoDouble(_Symbol,SYMBOL_BID)+_Point*40);
      }
      ObjectSetInteger(0,"trigger_level_dn"+id,OBJPROP_COLOR,Red);
      ObjectSetInteger(0,"trigger_level_dn"+id,OBJPROP_SELECTABLE,1);
      ObjectSetInteger(0,"trigger_level_dn"+id,OBJPROP_SELECTED,1);
   }
   return(INIT_SUCCEEDED);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   ObjectDelete(0, "trigger_level_dn"+id);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
  
   ArraySetAsSeries(close,true);
   ArraySetAsSeries(open,true);
   
   if (ObjectGetDouble(0,"trigger_level_dn"+id,OBJPROP_PRICE,0) != trigger)
     trigger = MathRound(ObjectGetDouble(0,"trigger_level_dn"+id,OBJPROP_PRICE,0)/_Point)*_Point;
   
   Comment(prevbid+" "+SymbolInfoDouble(_Symbol,SYMBOL_BID)+" "+trigger);
   
   if (((prevbid > trigger && SymbolInfoDouble(_Symbol,SYMBOL_BID) <= trigger) 
   ||   (prevbid < trigger && SymbolInfoDouble(_Symbol,SYMBOL_BID) >= trigger))
   &&   (trigger > 0))
   {
      string response = trade4me(username, password, Symbol(), "DOWN", expiry, investment);
      Alert(response);
      ObjectSetDouble(0,"trigger_level_dn"+id,OBJPROP_PRICE,0);
   }
   
   prevbid=SymbolInfoDouble(_Symbol,SYMBOL_BID);
   return(rates_total);
}
